SystemOrganization addCategory: #TusLibros!

Exception subclass: #MerchantProcessorException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

TestCase subclass: #EditorialTest
	instanceVariableNames: 'debitExcecutionBlock myDateAndTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 6/3/2013 18:48'!
carrito
	|catalogo|
	catalogo := self catalog .
	catalogo at: self libro put: 12.
	^Carrito newWithThisCatalog: catalogo.
	! !

!EditorialTest methodsFor: 'carritoIntansce' stamp: 'SebastianGarbi 5/29/2013 21:26'!
carrito: unCatalogo
	^Carrito newWithThisCatalog: unCatalogo.
	! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:06'!
cashier: aDate 
	^Cashier newWithThisDate:  aDate andThisSalesBook: OrderedCollection new.! !

!EditorialTest methodsFor: 'catalogInstances' stamp: 'SebastianGarbi 6/3/2013 18:43'!
catalog
	^Dictionary new.! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/5/2013 20:40'!
client
	^'asd1'.! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/5/2013 20:41'!
clientPassword
	^'sdfre34'.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'ebastian 6/5/2013 21:22'!
clientWrongPassword
	^'pass invalida.'.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:37'!
clockSimulatorInitialize: aDateAndTime 
	myDateAndTime := aDateAndTime. 
	^self.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:42'!
clockSimulatorPass30Min
	myDateAndTime := myDateAndTime+ (Duration days: 0 hours: 0 minutes: 30 seconds: 0).! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:42'!
clockSimulatorPass30MinAnd1Second
	myDateAndTime := myDateAndTime+ (Duration days: 0 hours: 0 minutes: 30 seconds: 1).! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:46'!
debitFrom: aCreditCard amount: aSmallInteger 
	^debitExcecutionBlock value: aCreditCard value: aSmallInteger.! !

!EditorialTest methodsFor: 'catalogInstances' stamp: 'ebastian 5/30/2013 21:39'!
emptyCatalog
	^Dictionary new.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
libro
	^'Libro1'.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
libroDeOtroCatalogo
	^'Libro2'.! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:51'!
merchantProcesorFail
	debitExcecutionBlock := [ :aCC :anAmount |
		self fail.
		] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/5/2013 18:54'!
merchantProcesorOk
	debitExcecutionBlock := [ :aCC :anAmount |
		true.
		] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/9/2013 15:38'!
merchantProcesorWithAllCreditCardsWithoutMoney
	debitExcecutionBlock := [ :aCC :anAmount |
		self error: Cashier CreditCardWithoutMoneyMessage .
	] .
	^self
	! !

!EditorialTest methodsFor: 'merchantProcessorSimulator' stamp: 'SebastianGarbi 6/9/2013 15:38'!
merchantProcesorWithAllStolenCreditCards
	debitExcecutionBlock := [ :aCC :anAmount |
		self error: Cashier CreditCardStolenMessage.
	] .
	^self
	! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:20'!
now
	^myDateAndTime.! !

!EditorialTest methodsFor: 'libroinstances' stamp: 'ebastian 6/3/2013 20:27'!
otroLibro
	^'Libro3'.! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 5/27/2013 21:09'!
test01CarritoShouldBeEmptyAfterCreation
	self assert: (self carrito isEmpty). ! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:43'!
test02CarritoMustHaveABookAfterAdding
	|unCarrito unLibro unNumero unCatalogo|
	unLibro := self libro.
	unCatalogo := self catalog .
	unCatalogo at: unLibro put: 1.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	unCarrito add:  unNumero of: unLibro . 
	self deny:  (unCarrito ) isEmpty. 
	self assert:  (unCarrito includes: unLibro). 
	self assert:  ((unCarrito amountOf: unLibro) = unNumero).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:44'!
test03CanIncreaseBookQuantity
	|unCarrito unLibro unNumero unCatalogo |
	unLibro := self libro.
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	
	
	unCarrito add: unNumero of: unLibro   .
	unCarrito add: unNumero of: unLibro   .

	 
	self assert:  ((unCarrito amountOf: unLibro) = (unNumero * 2)).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test04CanAddDifferentBooks
	|unCarrito unLibro otroLibro unNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro put: 12.
	unCatalogo at: otroLibro put: 13.
	unCarrito := self carrito: unCatalogo.
	unNumero := 1.
	
	
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: unNumero of: otroLibro  .
	
	
	 
	self assert: (unCarrito includes: unLibro).
	self assert: (unCarrito includes: otroLibro).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:45'!
test05AddingDifferentBooksRespectQuantities
	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro  put: 12.
	unCatalogo at: otroLibro put: 12.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	
	
	
	 
	self assert: (unCarrito amountOf: unLibro ) = unNumero .
	self assert: (unCarrito amountOf: otroLibro) = otroNumero .
	
	self assert: unCarrito size = (unNumero + otroNumero ).! !

!EditorialTest methodsFor: '01- Carrito' stamp: 'SebastianGarbi 6/3/2013 18:46'!
test06CarritoCanOnlyTakeCatalogBooks
	|unCarrito|
	unCarrito := self carrito .
	self should: [unCarrito add: self libroDeOtroCatalogo. self fail.] raise: Error withExceptionDo: [ :anError | self assert: anError  messageText  = Carrito invalidElementMessage .  
	self assert:  unCarrito isEmpty ].
	
	
	
! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:56'!
test07CashierDontSellAnEmptyCart
	| aCC aCashier aCatalog aCart |
	aCatalog := self emptyCatalog.
	aCC := CreditCard newName: 'juan perez' ccNumber: 128 expiration: Date today month.
	aCashier := self cashier: aCatalog.
	aCart := self carrito: aCatalog.
	self
		should: [ aCashier sellProducts: aCart withThisCreditCard: aCC withThisMP: self  merchantProcesorFail ]
		raise: Error
		withExceptionDo: [ :anError | 
			self assert: anError messageText = Cashier noProductsInCartMessage.
			self assert: aCart isEmpty ]! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:51'!
test08ASellWithanInvalidCreditCardShouldRaiseAnError
	| aCashier aCatalog aCart unLibro aCC1 aCC2 aCC3 |
	unLibro := self libro.
	aCatalog := self emptyCatalog.
	aCatalog at: unLibro put: 10.
	aCC1 := CreditCard newName: '' ccNumber: 123 expiration: Date today month.
	aCC2 := CreditCard newName: 'fruta' ccNumber: 0 expiration: Date today month.
	aCC3 := CreditCard newName: 'frutita' ccNumber: 123 expiration: Date today month previous.
	aCashier := self cashier: Date today.
	aCart := self carrito: aCatalog.
	aCart add: 1 of: unLibro.
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC1 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC2 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self
		should: [ 
			aCashier sellProducts: aCart withThisCreditCard: aCC3 withThisMP: self merchantProcesorFail.
			self fail ]
		raise: Error
		withExceptionDo: [ :anError | self assert: anError messageText = Cashier invalidCreditCardMessage ].
	self assert: aCashier salesBook isEmpty! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/8/2013 15:57'!
test09aCashierKnowsHowToCalculeASellAmount

	|unCarrito unLibro otroLibro unNumero otroNumero unCatalogo aCashier |
	unLibro := self libro.
	otroLibro := self otroLibro.
	
	unCatalogo := self catalog  .
	unCatalogo at: unLibro  put: 12.
	unCatalogo at: otroLibro put: 13.
	unCarrito := self carrito: unCatalogo.

	
	
	unNumero := 5.
	otroNumero := 4.
	
	unCarrito add: unNumero of: unLibro  .
	unCarrito add: otroNumero of: otroLibro  .
	aCashier :=  self cashier: Date today.
	
	
	self assert: ((unNumero * 12) + (otroNumero * 13) =  (aCashier calculateCartValue: unCarrito )) 
	
	! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:53'!
test09aCashierShouldCreateASaleWithAValidCreditCard
	| aCart aCatalog aCashier aCreditCard sum|
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorOk.
	
	self deny: aCashier salesBook isEmpty.
	self assert: aCashier salesBook first = (aCatalog at: self libro).
	
	sum := 0.
	aCashier salesBook do: [ :aSale | sum := sum + 1 ].
	self assert:  (sum = 1).
	



! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'SebastianGarbi 6/5/2013 18:46'!
test10aCashierShouldReturnAnErrorWithAStolenCreditCard
	| aCart aCatalog aCashier aCreditCard |
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	self should: [ aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorWithAllStolenCreditCards.
					self fail ]
		raise:  Error 
		withExceptionDo:  [ :anError | self assert: anError messageText = Cashier CreditCardStolenMessage ].
	
	self assert: aCashier salesBook isEmpty.
		



! !

!EditorialTest methodsFor: '02- Cashier' stamp: 'ebastian 6/4/2013 22:26'!
test11aCashierShouldReturnAnErrorWithACreditCardWithoutMoney
	| aCart aCatalog aCashier aCreditCard |
	"un catalogo con un libro"
	aCatalog := self catalog.
	aCatalog at: self libro put: 2.	
	
	"un carrito con un libro del catalogo"
	aCart := self carrito: aCatalog.
	aCart add: self libro.	
		
	"una tarjeta de credito valida"
	aCreditCard := CreditCard newName: 'dueoNombre' ccNumber: 123 expiration: Date today month.	
	
	"un cajero"
	aCashier := self cashier: Date today.
	
	self should: [ aCashier sellProducts: aCart withThisCreditCard: aCreditCard withThisMP: self merchantProcesorWithAllCreditCardsWithoutMoney.
					self fail ]
		raise:  Error 
		withExceptionDo:  [ :anError | self assert: anError messageText = Cashier CreditCardWithoutMoneyMessage ].
	
	self assert: aCashier salesBook isEmpty.
		



! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/5/2013 20:34'!
test13sendMessageCreateCartWithInvalidUserShouldthrowException
	self should: [self userInterface createCartFor: self client withPassword: self clientPassword. 
				self fail ] 
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
							self assert: anUserInterfaceException  messageText  = UserInterface invalidUserErrorMessage ].
	 
	! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/8/2013 16:35'!
test14sendMessageCreateCartWithAValidUserAndWrongPassShouldthrowException
	
	| anUserInterface  |
	
"	aFewUsersAndPass := Dictionary new.
	aFewUsersAndPass at: self client put: 'nonValid'.
	aCatalog := Dictionary new.
	anUserInterface := UserInterface newWithTheseUsersAndPass: aFewUsersAndPass andThisCatalog: aCatalog ."
	anUserInterface := self userInterfaceWhithSomeUsersAndPassAndACatalog.
	
	self should: [	anUserInterface createCartFor: self client withPassword: self clientWrongPassword. 
					self fail ] 
	raise: UserInterfaceException 
	withExceptionDo: [ :anUserInterfaceException | 
							self assert: anUserInterfaceException  messageText  = UserInterface invalidPassErrorMessage ].! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/8/2013 16:35'!
test15sendMessageCreateCartWithAValidUserAndAValidPassShouldBeCreateACartAndGiveMeACartID
	
	| anUserInterface cartID sum |
	
"	aFewUsersAndPass := Dictionary new.
	aFewUsersAndPass at: self client put: self clientPassword.
	
	aCatalog := Dictionary new.
	
	anUserInterface := UserInterface newWithTheseUsersAndPass: aFewUsersAndPass andThisCatalog: aCatalog ."
	anUserInterface := self userInterfaceWhithSomeUsersAndPassAndACatalog.

	cartID := anUserInterface createCartFor: self client withPassword: self clientPassword.
	
	self assert: (anUserInterface cartsIdsAndCarts keys allSatisfy: [ :aCartID | cartID = aCartID ] ).
	sum := 0.
	anUserInterface cartsIdsAndCarts keys do: [ :aCartID | sum := sum + 1 ].
	self assert: sum = 1.
	! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/9/2013 15:25'!
test16sendMessagesAddToCartListCartCheckoutCartWithAnInvalidIDShouldThrowException
	
	| anUserInterface anInvalidID |
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalog.
	
	anUserInterface createCartFor: self client withPassword: self clientPassword.
	anInvalidID := 'Otra cosa'.
	
	self should: [
		anUserInterface addToCart: anInvalidID  thisBook: self libro thisQuantity: 4.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface invalidCartIdErrorMessage].
	self should: [
		anUserInterface listCart: anInvalidID.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface invalidCartIdErrorMessage].
	self should: [
		anUserInterface checkOutCart:  anInvalidID ccn: 123 cced: Date today month cco: 'Fulano De Tal' mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface invalidCartIdErrorMessage].! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/9/2013 15:25'!
test17sendMessagesAddToCartListCartCheckoutCartWhitAvalidCartIdAndPassed30MinAfterAccesingShoulThrowAnException
	
	| anUserInterface cartId |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.
	self clockSimulatorPass30MinAnd1Second .
	self should: [
		anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface cartExpiredErrorMessage].
	self should: [
		anUserInterface listCart: cartId.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface cartExpiredErrorMessage].
	self should: [
		anUserInterface checkOutCart: cartId ccn: 123 cced: Date today month cco: 'Cosme Fulanito' mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException 
		withExceptionDo: [ :anUserInterfaceException | 
			self assert: anUserInterfaceException  messageText  = UserInterface cartExpiredErrorMessage].! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/8/2013 18:42'!
test18sendMessageAddToCartWhitAvalidCartIdAndANotExpiredCartShouldReturnTRUE
	
	| anUserInterface cartId |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.
	self assert: (anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4).
! !

!EditorialTest methodsFor: '03- Interface' stamp: 'ebastian 6/10/2013 02:20'!
test19sendMessageListCartWhitAvalidCartIdAndANotExpiredCartShouldReturnTheCartContents
	
	| anUserInterface cartId aCartContents |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.
	anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4.
	anUserInterface addToCart: cartId thisBook: self otroLibro thisQuantity: 8.
	aCartContents := anUserInterface listCart: cartId.
	self assert: (aCartContents allSatisfy: [ :elem | (elem = self libro) or: (elem = self otroLibro)]).
	self assert: ( (aCartContents occurrencesOf: self libro) = 4 and: ((aCartContents occurrencesOf: self otroLibro) = 8) ).
		
	
! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/9/2013 16:15'!
test20sendMessageCheckOutCartWhitAvalidCartIdANotExpiredCartAndAProblemCreditCardShouldThrowExceptionWhithCorrectMessage
	
	| anUserInterface cartId  aValidCCN aValidCCED aValidCCO |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.
	aValidCCN := 123456.
	aValidCCED := Date today month.
	aValidCCO := 'Cosme Fulanito'.

	self should: [
		anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier noProductsInCartMessage ].

	anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4.
	anUserInterface addToCart: cartId thisBook: self otroLibro thisQuantity: 8.
		
	self should: [
		anUserInterface checkOutCart: cartId ccn: 0 cced: aValidCCED cco: aValidCCO mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier invalidCreditCardMessage ].
	self should: [
		anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED previous cco: aValidCCO mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier invalidCreditCardMessage ].
	self should: [
		anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: '' mp: self merchantProcesorFail.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier invalidCreditCardMessage ].
	self should: [
		anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: self merchantProcesorWithAllCreditCardsWithoutMoney.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier CreditCardWithoutMoneyMessage].
	self should: [
		anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: self merchantProcesorWithAllStolenCreditCards.
		self fail.
		]
		raise: UserInterfaceException
		withExceptionDo: [ :anUIException |
			self assert: anUIException  messageText  = Cashier CreditCardStolenMessage].! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/9/2013 16:59'!
test21sendMessageCheckOutCartWhitAvalidCartIdANotExpiredCartAndACorrectCreditCardShouldReturnATransactionID
	
	| anUserInterface cartId  aValidCCN aValidCCED aValidCCO aCartList |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.
	aValidCCN := 123456.
	aValidCCED := Date today month.
	aValidCCO := 'Cosme Fulanito'.
	anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4.
	anUserInterface addToCart: cartId thisBook: self otroLibro thisQuantity: 8.
	aCartList := anUserInterface listCart: cartId.
		
	anUserInterface transactions 
		at: 	(anUserInterface checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: self merchantProcesorOk)
		ifPresent: [ :value |
				self assert: (value = aCartList).
				self should: [anUserInterface cartForID: cartId. self fail]
				raise: UserInterfaceException
				withExceptionDo: [ :anError | anError messageText = UserInterface invalidCartIdErrorMessage]
			]
		ifAbsent: [ self fail]
! !

!EditorialTest methodsFor: '03- Interface' stamp: 'ebastian 6/10/2013 02:43'!
test22sendMessagelistPurchasesWhitAvalidUserIdAndAValidPassShouldReturnThePurchasedList
	
	| anUserInterface cartId  aValidCCN aValidCCED aValidCCO aMerchantProcesorOK aBag |
	
	self clockSimulatorInitialize: DateAndTime now.
	anUserInterface  := self userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: self.
	cartId := anUserInterface createCartFor: self client withPassword: self clientPassword.

	aValidCCN := 123456.
	aValidCCED := Date today month.
	aValidCCO := 'Cosme Fulanito'.
	
	aMerchantProcesorOK := self merchantProcesorOk.
	
	anUserInterface addToCart: cartId thisBook: self libro thisQuantity: 4.
	anUserInterface addToCart: cartId thisBook: self otroLibro thisQuantity: 8.
	
	anUserInterface  checkOutCart: cartId ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: aMerchantProcesorOK.

	self assert: ((anUserInterface listPurchasesOf: self client withThisPass: self clientPassword) size = 1).
	
	(anUserInterface listPurchasesOf: self client withThisPass: self clientPassword) do: [ :anOtherBag | aBag := anOtherBag ].
	self assert: ( aBag allSatisfy: [ :aProduct | (aProduct = self libro) or: [aProduct = self otroLibro] ] ).
	self assert: ((aBag occurrencesOf: self libro) = 4 and: [ (aBag occurrencesOf: self otroLibro) = 8 ]).

! !

!EditorialTest methodsFor: '03- Interface' stamp: 'ebastian 6/10/2013 03:12'!
test23sendMessagelistPurchasesWhitAvalidUserIdAndAValidPassShouldReturnThePurchasedList
	"mismo de antes pero ahora hacemos 2 checkouts"
	| anUserInterface cartId1  aValidCCN aValidCCED aValidCCO aMerchantProcesorOK aFewUsersAndPass aCatalog |
	
	self clockSimulatorInitialize: DateAndTime now.
	
	aFewUsersAndPass := Dictionary new.
	aFewUsersAndPass at: self client put: self clientPassword.
	aFewUsersAndPass at: 'client46' put: '1234567890'.
	
	aCatalog := Dictionary new.
	aCatalog at: self libro put: 25.
	aCatalog at: self otroLibro put:32.
	
	anUserInterface := UserInterface newWithTheseUsersAndPass: aFewUsersAndPass andThisCatalog: aCatalog andThisClock: self.
	
	aValidCCN := 123456.
	aValidCCED := Date today month.
	aValidCCO := 'Cosme Fulanito'.
	
	aMerchantProcesorOK := self merchantProcesorOk.
	
	cartId1 := anUserInterface createCartFor: self client withPassword: self clientPassword.
	anUserInterface addToCart: cartId1 thisBook: self libro thisQuantity: 4.
	anUserInterface addToCart: cartId1 thisBook: self otroLibro thisQuantity: 8.
	anUserInterface checkOutCart: cartId1 ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: aMerchantProcesorOK.
	
	cartId1 := anUserInterface createCartFor: self client withPassword: self clientPassword.
	anUserInterface addToCart: cartId1 thisBook: self libro thisQuantity: 3.
	anUserInterface addToCart: cartId1 thisBook: self otroLibro thisQuantity: 3.
	anUserInterface checkOutCart: cartId1 ccn: aValidCCN cced: aValidCCED cco: aValidCCO mp: aMerchantProcesorOK.
	
	self assert: ((anUserInterface listPurchasesOf: self client withThisPass: self clientPassword) size = 2).
	
	self assert: ((anUserInterface listPurchasesOf: self client withThisPass: self clientPassword) allSatisfy: [ :aBag | 
			(aBag allSatisfy: [ :aProduct | (aProduct = self libro) or: [aProduct = self otroLibro] ]) and: 
			[ ((aBag occurrencesOf: self libro) = 4 and: [ (aBag occurrencesOf: self otroLibro) = 8 ]) or:
				[ (aBag occurrencesOf: self libro) = 3 and: [ (aBag occurrencesOf: self otroLibro) = 3 ] ]
			]
		]).

! !

!EditorialTest methodsFor: '03- Interface' stamp: 'SebastianGarbi 6/8/2013 16:30'!
userInterface
	^UserInterface newWithTheseUsersAndPass: Dictionary new andThisCatalog: Dictionary new andThisClock: DateAndTime now.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:10'!
userInterfaceWhithSomeUsersAndPassAndACatalog
	| aFewUsersAndPass aCatalog anUserInterface|
	aFewUsersAndPass := Dictionary new.
	aFewUsersAndPass at: self client put: self clientPassword.
	aCatalog := Dictionary new.
	aCatalog at: self libro put: 25.
	aCatalog at: self otroLibro put:32.
	anUserInterface := UserInterface newWithTheseUsersAndPass: aFewUsersAndPass andThisCatalog: aCatalog andThisClock: DateAndTime.
	^anUserInterface.! !

!EditorialTest methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:38'!
userInterfaceWhithSomeUsersAndPassAndACatalogAndThisClock: aClock
	| aFewUsersAndPass aCatalog anUserInterface|
	aFewUsersAndPass := Dictionary new.
	aFewUsersAndPass at: self client put: self clientPassword.
	aCatalog := Dictionary new.
	aCatalog at: self libro put: 25.
	aCatalog at: self otroLibro put:32.
	anUserInterface := UserInterface newWithTheseUsersAndPass: aFewUsersAndPass andThisCatalog: aCatalog andThisClock: aClock.
	^anUserInterface.! !

Error subclass: #UserInterfaceException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Carrito
	instanceVariableNames: 'catalogo canasto'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:58'!
invalidElementError
	self error: self invalidElementMessage.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:22'!
invalidElementMessage
	^'No se puede agregar algo que no pertenece al catalogo'.! !

!Carrito class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:17'!
newWithThisCatalog: aCatalog
	^self new initializeWith: aCatalog. ! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:55'!
add: unElemento
	
	self add: 1 of: unElemento.
! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:41'!
add: aSmallInteger of: anObject 
	catalogo at: anObject  ifAbsent:  [self class invalidElementError].
	"(catalogo includes: anObject) ifFalse: [self class invalidElementError]."
	canasto add: anObject  withOccurrences: aSmallInteger.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:43'!
amountOf: anObject 
	^canasto occurrencesOf: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 20:20'!
catalog
	^catalogo.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:41'!
includes: anObject 
	^canasto includes: anObject .! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initialize 
	canasto := Bag new.

	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 21:18'!
initializeWith: aCatalog 
	
	catalogo := aCatalog .
	^self.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:35'!
isEmpty
	^canasto isEmpty.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 19:32'!
products
	^canasto.! !

!Carrito methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 5/29/2013 20:49'!
size
	^canasto size.! !

Object subclass: #CarritoAndAcces
	instanceVariableNames: 'carrito lastAccess clientID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CarritoAndAcces class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:27'!
newCarrito: aCarrito lastActivity: aDateAndTime clientID:aClientID 
	^self new initializeWith: aCarrito andThisLastAccess: aDateAndTime andThisClientID: aClientID.
	"^self new initializeWhit: aCarrito and: aDateAndTime."! !

!CarritoAndAcces methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 18:42'!
carrito
	^ carrito! !

!CarritoAndAcces methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 02:05'!
clientID
	^clientID.! !

!CarritoAndAcces methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:26'!
initializeWith: aCarrito andThisLastAccess: aDateAndTime andThisClientID: aClientID
	carrito := aCarrito.
	lastAccess := aDateAndTime.
	clientID := aClientID.
	^self.! !

!CarritoAndAcces methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:24'!
lastAccess
	^ lastAccess! !

Object subclass: #Cashier
	instanceVariableNames: 'dateToday salesBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'error handling' stamp: 'SebastianGarbi 6/5/2013 18:34'!
CreditCardStolenMessage
	^'Tarjeta estolen cal de police '.! !

!Cashier class methodsFor: 'error handling' stamp: 'SebastianGarbi 6/5/2013 18:48'!
CreditCardWithoutMoneyMessage
	^'No hay money'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/3/2013 18:38'!
invalidCreditCardMessage
	^'La tarjeta no sirve!!!!   pobre'.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:03'!
newWithThisDate: aDate andThisSalesBook: aSalesBook
	^self new initializeWith: aDate andThisSalesBook: aSalesBook.! !

!Cashier class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 14:41'!
noProductsInCartMessage
	^'No hay productos en el carrito para vender'.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 20:04'!
calculateCartValue: aCart 
	| total |
	total := 0.
	aCart products do: [ :aProduct | total:= total + ( aCart catalog at: aProduct )].
	^total.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:04'!
initializeWith: aDate andThisSalesBook: aSalesBook.
	dateToday := aDate. 
	salesBook := aSalesBook.
	^self.! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 20:15'!
isThisAValidCC: aCC 
	^((aCC owner ~= '')  and: (aCC creditCardNumber > 0)) and: (aCC expiration  >= dateToday month ).! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'ebastian 6/3/2013 21:09'!
salesBook
	^ salesBook! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/4/2013 19:56'!
sellProducts: aCart withThisCreditCard: aCC withThisMP: aMerchantProcessor
	
	(aCart isEmpty ) ifTrue: [self error: Cashier noProductsInCartMessage].
	(self isThisAValidCC:  aCC  ) ifFalse: [ self error: Cashier invalidCreditCardMessage ].
	aMerchantProcessor debitFrom: aCC amount: (self calculateCartValue: aCart ).
	salesBook add: (self calculateCartValue: aCart).
	
	"hay que seguir"! !

Object subclass: #CreditCard
	instanceVariableNames: 'owner creditCardNumber expiration'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:05'!
newName: aByteString ccNumber: aSmallInteger expiration: month 
	^self new initializeWithName: aByteString ccNumber: aSmallInteger expiration: month.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
creditCardNumber
	^ creditCardNumber.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 5/30/2013 22:59'!
expiration
	
	^ expiration! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:55'!
initializeWithName: aByteString ccNumber: aSmallInteger expiration: month 
	owner := aByteString.
	creditCardNumber := aSmallInteger.
	expiration := month.
	^self.! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'ebastian 6/2/2013 12:54'!
owner
	^owner.! !

Object subclass: #UserInterface
	instanceVariableNames: 'usersAndPass cartsIdsAndCarts catalog clock lastId salesBook transactions purchases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!UserInterface class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:46'!
cartExpiredErrorMessage
	^'El Carrito expir porque no fue accedido en mas de 30 minutos'.! !

!UserInterface class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:14'!
invalidCartIdErrorMessage
	^'Id de Carrito invlido'.! !

!UserInterface class methodsFor: 'as yet unclassified' stamp: 'ebastian 6/5/2013 21:23'!
invalidPassErrorMessage
	^'Pass Invalida'.! !

!UserInterface class methodsFor: 'error handling' stamp: 'SebastianGarbi 6/5/2013 21:07'!
invalidUserErrorMessage
	^'Usuario Invalido!!!!!! tutto feo'.! !

!UserInterface class methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 16:32'!
newWithTheseUsersAndPass: aDictionary andThisCatalog: aCatalog andThisClock: aDateAndTime
	^self new initializeWithTheseUsersAndPass: aDictionary andThisCatalog: aCatalog andThisClock: aDateAndTime.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:42'!
addToCart: aCartId thisBook: anIsbnId thisQuantity: aSmallInteger 
	| aCart |
	aCart := self cartForID: aCartId.
	aCart add: aSmallInteger of: anIsbnId.
	"self atThisID: aCartId put: aCart."
	^true.
	! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:31'!
atThisID: aCartID put: aCarrito withThisClient: aClientID
	cartsIdsAndCarts at: aCartID put: (CarritoAndAcces newCarrito: aCarrito lastActivity: (self clock now) clientID: aClientID).! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:49'!
cartForID: aCartId
	| aCartAndClock |
	cartsIdsAndCarts at: aCartId ifPresent: [ :aValue | aCartAndClock := aValue] ifAbsent: [ UserInterfaceException signal: UserInterface invalidCartIdErrorMessage ].
	(aCartAndClock lastAccess + (Duration days: 0 hours: 0 minutes: 30 seconds: 0) < self clock now) ifTrue: [ UserInterfaceException signal: UserInterface cartExpiredErrorMessage].
	^aCartAndClock carrito.! !

!UserInterface methodsFor: 'user interface' stamp: 'ebastian 6/7/2013 01:59'!
cartsIdsAndCarts
	^cartsIdsAndCarts.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:02'!
catalog
	^ catalog! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 02:02'!
checkOutCart: aCartId ccn: aSmallInteger cced: aMonth cco: anOwnerName mp: aMerchantProcesor 
	| aCart aCashier aTransactionID |
	aCart := self cartForID: aCartId.
	aCashier := Cashier newWithThisDate: self clock now asDate andThisSalesBook: self salesBook.
	[ 
		[
			aCashier sellProducts: aCart withThisCreditCard: (CreditCard newName: anOwnerName ccNumber: aSmallInteger expiration: aMonth) withThisMP: aMerchantProcesor.
			
			aTransactionID := self generateTransactionID.
			transactions at: aTransactionID put: aCart products.
			
			(purchases at: (cartsIdsAndCarts at: aCartId) clientID ifAbsentPut: [ OrderedCollection new ]) add: aCart products.
			
			cartsIdsAndCarts removeKey: aCartId.
			^aTransactionID.
		]
		on: MerchantProcessorException
		do: [ :anMPExepcion |
			UserInterfaceException signal: anMPExepcion messageText.
		].
	]
	on: Error
	do: [ :aCashierError |
		UserInterfaceException signal: aCashierError messageText.
		]! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/8/2013 17:03'!
clock
	^ clock! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:39'!
createCartFor: aClientID withPassword: aPassword 
	| aCartID |
	self isValid: aClientID withThisPass: aPassword.
	aCartID := self generateCartID.
	self atThisID: aCartID put: (Carrito newWithThisCatalog: self catalog) withThisClient: aClientID.
	^aCartID.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/9/2013 16:29'!
generateCartID
	lastId  := (lastId + 13)*7.
	^'Cart', lastId printString .
	! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/9/2013 16:31'!
generateTransactionID
	lastId  := (lastId + 5)*3.
	^'Transaction', lastId printString .
	! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 00:56'!
initializeWithTheseUsersAndPass: aUsersAndPass andThisCatalog: aCatalog andThisClock: aClock
	transactions := Dictionary new.
	purchases := Dictionary new.
	usersAndPass := aUsersAndPass.
	cartsIdsAndCarts := Dictionary new.
	salesBook := OrderedCollection new.
	catalog := aCatalog.
	clock := aClock.
	lastId := 0.
	^self.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/5/2013 21:35'!
isValid: aClientId withThisPass: aPass
	usersAndPass at: aClientId 
					ifPresent: [ :aValue | (aValue = aPass) ifFalse: [ UserInterfaceException signal: UserInterface invalidPassErrorMessage ] ] 
					ifAbsent: [UserInterfaceException signal: UserInterface invalidUserErrorMessage] .
	^true.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/9/2013 15:05'!
listCart: aCartId
	^(self cartForID: aCartId) products.
	! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'ebastian 6/10/2013 01:51'!
listPurchasesOf: aClientID withThisPass: aPassword 
	self isValid: aClientID withThisPass: aPassword.
	^purchases at: aClientID ifAbsent: [ ^OrderedCollection new ].
	! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/9/2013 15:55'!
salesBook
	^salesBook.! !

!UserInterface methodsFor: 'as yet unclassified' stamp: 'SebastianGarbi 6/9/2013 16:37'!
transactions
	^transactions.! !
